DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Virtual Scrolling

With virtual scrolling, you can improve the overall performance of your application and reduce load times when our JavaScript Scheduler component is bound to a large data set. When virtual scrolling is enabled, our JavaScript Scheduler only renders visible appointments. When an appointment leaves the viewport, the JavaScript Scheduler removes it from the DOM.

To enable virtual scrolling mode, set the scrolling.mode property to "virtual".

Virtual scrolling is available for all views except "agenda".

Backend API
$(() => { const startDay = new Date(2021, 1, 1); const endDay = new Date(2021, 1, 28); const startDayHour = 8; const endDayHour = 20; const appointments = generateAppointments(startDay, endDay, startDayHour, endDayHour); $('#scheduler').dxScheduler({ height: 730, currentDate: new Date(2021, 1, 2), dataSource: appointments, views: [ { type: 'timelineWorkWeek', name: 'Timeline', groupOrientation: 'vertical', }, { type: 'workWeek', groupOrientation: 'vertical', }, { type: 'month', groupOrientation: 'horizontal', }, ], currentView: 'Timeline', startDayHour, endDayHour, cellDuration: 60, scrolling: { mode: 'virtual', }, showAllDayPanel: false, groups: ['humanId'], resources: [{ fieldExpr: 'humanId', dataSource: resources, label: 'Employee', icon: 'group', }], }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="scheduler"></div> </div> </body> </html>
#scheduler .dx-scheduler-cell-sizes-vertical { height: 100px; } #scheduler .dx-scheduler-cell-sizes-horizontal { width: 100px; }
const resources = [{ id: 0, text: 'David Carter', color: '#74d57b', }, { id: 1, text: 'Emma Lewis', color: '#1db2f5', }, { id: 2, text: 'Noah Hill', color: '#f5564a', }, { id: 3, text: 'William Bell', color: '#97c95c', }, { id: 4, text: 'Jane Jones', color: '#ffc720', }, { id: 5, text: 'Violet Young', color: '#eb3573', }, { id: 6, text: 'Samuel Perry', color: '#a63db8', }, { id: 7, text: 'Luther Murphy', color: '#ffaa66', }, { id: 8, text: 'Craig Morris', color: '#2dcdc4', }, { id: 9, text: 'Sandy Wood', color: '#c34cb9', }, { id: 10, text: 'Susan Bennett', color: '#3d44ec', }, { id: 11, text: 'Lilly Barnes', color: '#4ddcca', }, { id: 12, text: 'Marcus Price', color: '#2ec98d', }, { id: 13, text: 'David Stewart', color: '#3ff6ca', }, { id: 14, text: 'Joseph Smith', color: '#f665aa', }, { id: 15, text: 'Carter Wilson', color: '#d1c974', }, { id: 16, text: 'Wyatt Lopez', color: '#ff6741', }, { id: 17, text: 'John Long', color: '#ee53dc', }, { id: 18, text: 'Jack Rivera', color: '#795ac3', }, { id: 19, text: 'Victoria Adams', color: '#ff7d8a', }, { id: 20, text: 'Madison Anderson', color: '#4cd482', }, { id: 21, text: 'Luna Moore', color: '#9d67cc', }, { id: 22, text: 'Michael Bailey', color: '#5ab1ef', }, { id: 23, text: 'Jenny Powell', color: '#68e18f', }, { id: 24, text: 'Daniel Peterson', color: '#4dd155', }, { id: 25, text: 'Gabriel Gray', color: '#ef9e44', }, { id: 26, text: 'Anthony Robinson', color: '#45a5cc', }, { id: 27, text: 'Ellie Tomson', color: '#a067bd', }, { id: 28, text: 'Natalie Adams', color: '#3d44ec', }, { id: 29, text: 'Sofia Green', color: '#4ddcca', }]; const appointmentsText = [ 'Google AdWords Strategy', 'New Brochures', 'Brochure Design Review', 'Website Re-Design Plan', 'Rollout of New Website and Marketing Brochures', 'Update Sales Strategy Documents', 'Non-Compete Agreements', 'Approve Hiring of John Jeffers', 'Update NDA Agreement', 'Update Employee Files with New NDA', 'Submit Questions Regarding New NDA', 'Submit Signed NDA', 'Review Revenue Projections', 'Comment on Revenue Projections', 'Provide New Health Insurance Docs', 'Review Changes to Health Insurance Coverage', 'Review Training Course for any Ommissions', 'Recall Rebate Form', 'Create Report on Customer Feedback', 'Review Customer Feedback Report', 'Customer Feedback Report Analysis', 'Prepare Shipping Cost Analysis Report', 'Provide Feedback on Shippers', 'Select Preferred Shipper', 'Complete Shipper Selection Form', 'Upgrade Server Hardware', 'Upgrade Personal Computers', 'Upgrade Apps to Windows RT or stay with WinForms', 'Estimate Time Required to Touch-Enable Apps', 'Report on Tranistion to Touch-Based Apps', 'Submit New Website Design', 'Create Icons for Website', 'Create New Product Pages', 'Approve Website Launch', 'Update Customer Shipping Profiles', 'Create New Shipping Return Labels', 'Get Design for Shipping Return Labels', 'PSD needed for Shipping Return Labels', 'Contact ISP and Discuss Payment Options', 'Prepare Year-End Support Summary Report', 'Review New Training Material', 'Distribute Training Material to Support Staff', 'Training Material Distribution Schedule', 'Approval on Converting to New HDMI Specification', 'Create New Spike for Automation Server', 'Code Review - New Automation Server', 'Confirm Availability for Sales Meeting', 'Reschedule Sales Team Meeting', 'Send 2 Remotes for Giveaways', 'Discuss Product Giveaways with Management', 'Replace Desktops on the 3rd Floor', 'Update Database with New Leads', 'Mail New Leads for Follow Up', 'Send Territory Sales Breakdown', 'Territory Sales Breakdown Report', 'Report on the State of Engineering Dept', 'Staff Productivity Report', ]; function getRandomDuration(durationState) { const durationMin = Math.floor((durationState % 23) / 3 + 5) * 15; return durationMin * 60 * 1000; } function getAppointmentText(textIndex) { return appointmentsText[textIndex % appointmentsText.length]; } function filterAppointmentsByTime(appointments, startDayHour, endDayHour) { const result = []; for (let i = 0; i < appointments.length; i += 1) { const { startDate } = appointments[i]; const { endDate } = appointments[i]; if (startDate.getDay() === endDate.getDay() && startDate.getHours() >= startDayHour - 1 && endDate.getHours() <= endDayHour - 1) { result.push(appointments[i]); } } return result; } function generateAppointments(startDay, endDay, startDayHour, endDayHour) { const appointments = []; let textIndex = 0; let durationState = 1; const durationIncrement = 19; for (let i = 0; i < resources.length; i += 1) { let startDate = startDay; while (startDate.getTime() < endDay.getTime()) { durationState += durationIncrement; const endDate = new Date(startDate.getTime() + getRandomDuration(durationState)); appointments.push({ text: getAppointmentText(textIndex), startDate, endDate, humanId: resources[i].id, }); textIndex += 1; durationState += durationIncrement; startDate = new Date(endDate.getTime() + getRandomDuration(durationState)); } } return filterAppointmentsByTime(appointments, startDayHour, endDayHour); }

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Angular Scheduler - Virtual Scrolling

With virtual scrolling, you can improve the overall performance of your application and reduce load times when our Scheduler component is bound to a large data set. When virtual scrolling is enabled, our Scheduler only renders visible appointments. When an appointment leaves the viewport, the Scheduler removes it from the DOM.

To enable virtual scrolling mode, set the scrolling.mode property to "virtual".

Virtual scrolling is available for all views except "agenda".

Backend API
<dx-scheduler [height]="730" [currentDate]="currentDate" [dataSource]="appointments" currentView="Timeline" [startDayHour]="8" [endDayHour]="20" [cellDuration]="60" [showAllDayPanel]="false" [groups]="['humanId']" > <dxi-scheduler-view type="timelineWorkWeek" name="Timeline" groupOrientation="vertical" ></dxi-scheduler-view> <dxi-scheduler-view type="workWeek" groupOrientation="vertical" ></dxi-scheduler-view> <dxi-scheduler-view type="month" groupOrientation="horizontal" ></dxi-scheduler-view> <dxi-scheduler-resource fieldExpr="humanId" [dataSource]="resources" label="Employee" icon="group" > </dxi-scheduler-resource> <dxo-scheduler-scrolling mode="virtual"> </dxo-scheduler-scrolling> </dx-scheduler>
import { bootstrapApplication } from '@angular/platform-browser'; import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core'; import { DxSchedulerModule } from 'devextreme-angular'; import { Resource, Appointment, Service } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } let modulePrefix = ''; // @ts-ignore if (window && window.config?.packageConfigPaths) { modulePrefix = '/app'; } @Component({ selector: 'demo-app', templateUrl: `app/app.component.html`, styleUrls: [`app/app.component.css`], providers: [Service], imports: [ DxSchedulerModule, ], }) export class AppComponent { resources: Resource[]; appointments: Appointment[]; currentDate: Date = new Date(2021, 1, 2); constructor(service: Service) { const startDay = new Date(2021, 1, 1); const endDay = new Date(2021, 1, 28); const startDayHour = 8; const endDayHour = 20; this.appointments = service.generateAppointments(startDay, endDay, startDayHour, endDayHour); this.resources = service.resources; } } bootstrapApplication(AppComponent, { providers: [ provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }), ], });
::ng-deep .dx-scheduler-timeline .dx-scheduler-date-table .dx-scheduler-cell-sizes-vertical, ::ng-deep .dx-scheduler-date-table .dx-scheduler-cell-sizes-vertical { height: 100px; } ::ng-deep .dx-scheduler-timeline .dx-scheduler-date-table .dx-scheduler-cell-sizes-horizontal, ::ng-deep .dx-scheduler-timeline .dx-scheduler-header-panel .dx-scheduler-cell-sizes-horizontal, ::ng-deep .dx-scheduler-date-table .dx-scheduler-cell-sizes-horizontal { width: 100px; }
import { Injectable } from '@angular/core'; export class Appointment { text: string; startDate: Date; endDate: Date; humanId: number; } export class Resource { id: number; text: string; color: string; } const resources: Resource[] = [{ id: 0, text: 'David Carter', color: '#74d57b', }, { id: 1, text: 'Emma Lewis', color: '#1db2f5', }, { id: 2, text: 'Noah Hill', color: '#f5564a', }, { id: 3, text: 'William Bell', color: '#97c95c', }, { id: 4, text: 'Jane Jones', color: '#ffc720', }, { id: 5, text: 'Violet Young', color: '#eb3573', }, { id: 6, text: 'Samuel Perry', color: '#a63db8', }, { id: 7, text: 'Luther Murphy', color: '#ffaa66', }, { id: 8, text: 'Craig Morris', color: '#2dcdc4', }, { id: 9, text: 'Sandy Wood', color: '#c34cb9', }, { id: 10, text: 'Susan Bennett', color: '#3d44ec', }, { id: 11, text: 'Lilly Barnes', color: '#4ddcca', }, { id: 12, text: 'Marcus Price', color: '#2ec98d', }, { id: 13, text: 'David Stewart', color: '#3ff6ca', }, { id: 14, text: 'Joseph Smith', color: '#f665aa', }, { id: 15, text: 'Carter Wilson', color: '#d1c974', }, { id: 16, text: 'Wyatt Lopez', color: '#ff6741', }, { id: 17, text: 'John Long', color: '#ee53dc', }, { id: 18, text: 'Jack Rivera', color: '#795ac3', }, { id: 19, text: 'Victoria Adams', color: '#ff7d8a', }, { id: 20, text: 'Madison Anderson', color: '#4cd482', }, { id: 21, text: 'Luna Moore', color: '#9d67cc', }, { id: 22, text: 'Michael Bailey', color: '#5ab1ef', }, { id: 23, text: 'Jenny Powell', color: '#68e18f', }, { id: 24, text: 'Daniel Peterson', color: '#4dd155', }, { id: 25, text: 'Gabriel Gray', color: '#ef9e44', }, { id: 26, text: 'Anthony Robinson', color: '#45a5cc', }, { id: 27, text: 'Ellie Tomson', color: '#a067bd', }, { id: 28, text: 'Natalie Adams', color: '#3d44ec', }, { id: 29, text: 'Sofia Green', color: '#4ddcca', }]; const appointmentsText: string[] = [ 'Google AdWords Strategy', 'New Brochures', 'Brochure Design Review', 'Website Re-Design Plan', 'Rollout of New Website and Marketing Brochures', 'Update Sales Strategy Documents', 'Non-Compete Agreements', 'Approve Hiring of John Jeffers', 'Update NDA Agreement', 'Update Employee Files with New NDA', 'Submit Questions Regarding New NDA', 'Submit Signed NDA', 'Review Revenue Projections', 'Comment on Revenue Projections', 'Provide New Health Insurance Docs', 'Review Changes to Health Insurance Coverage', 'Review Training Course for any Ommissions', 'Recall Rebate Form', 'Create Report on Customer Feedback', 'Review Customer Feedback Report', 'Customer Feedback Report Analysis', 'Prepare Shipping Cost Analysis Report', 'Provide Feedback on Shippers', 'Select Preferred Shipper', 'Complete Shipper Selection Form', 'Upgrade Server Hardware', 'Upgrade Personal Computers', 'Upgrade Apps to Windows RT or stay with WinForms', 'Estimate Time Required to Touch-Enable Apps', 'Report on Tranistion to Touch-Based Apps', 'Submit New Website Design', 'Create Icons for Website', 'Create New Product Pages', 'Approve Website Launch', 'Update Customer Shipping Profiles', 'Create New Shipping Return Labels', 'Get Design for Shipping Return Labels', 'PSD needed for Shipping Return Labels', 'Contact ISP and Discuss Payment Options', 'Prepare Year-End Support Summary Report', 'Review New Training Material', 'Distribute Training Material to Support Staff', 'Training Material Distribution Schedule', 'Approval on Converting to New HDMI Specification', 'Create New Spike for Automation Server', 'Code Review - New Automation Server', 'Confirm Availability for Sales Meeting', 'Reschedule Sales Team Meeting', 'Send 2 Remotes for Giveaways', 'Discuss Product Giveaways with Management', 'Replace Desktops on the 3rd Floor', 'Update Database with New Leads', 'Mail New Leads for Follow Up', 'Send Territory Sales Breakdown', 'Territory Sales Breakdown Report', 'Report on the State of Engineering Dept', 'Staff Productivity Report', ]; @Injectable() export class Service { get resources() { return resources; } get appointmentsText() { return appointmentsText; } getRandomDuration(durationState): number { const durationMin = Math.floor((durationState % 23) / 3 + 5) * 15; return durationMin * 60 * 1000; } getRandomText(textIndex): string { return appointmentsText[textIndex % appointmentsText.length]; } filterAppointmentsByTime(appointments, startDayHour, endDayHour): Appointment[] { const result = []; for (let i = 0; i < appointments.length; i += 1) { const startDate = appointments[i].startDate; const endDate = appointments[i].endDate; if (startDate.getDay() === endDate.getDay() && startDate.getHours() >= startDayHour - 1 && endDate.getHours() <= endDayHour - 1) { result.push(appointments[i]); } } return result; } generateAppointments(startDay, endDay, startDayHour, endDayHour): Appointment[] { const appointments = []; let textIndex = 0; let durationState = 1; const durationIncrement = 19; for (let i = 0; i < resources.length; i += 1) { let startDate = startDay; while (startDate.getTime() < endDay.getTime()) { durationState += durationIncrement; const endDate = new Date(startDate.getTime() + this.getRandomDuration(durationState)); appointments.push({ text: this.getRandomText(textIndex), startDate, endDate, humanId: resources[i].id, }); textIndex += 1; durationState += durationIncrement; startDate = new Date(endDate.getTime() + this.getRandomDuration(durationState)); } } return this.filterAppointmentsByTime(appointments, startDayHour, endDayHour); } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ const componentNames = [ 'accordion', 'action-sheet', 'autocomplete', 'bar-gauge', 'box', 'bullet', 'button-group', 'button', 'calendar', 'card-view', 'chart', 'chat', 'check-box', 'circular-gauge', 'color-box', 'context-menu', 'data-grid', 'date-box', 'date-range-box', 'defer-rendering', 'diagram', 'draggable', 'drawer', 'drop-down-box', 'drop-down-button', 'file-manager', 'file-uploader', 'filter-builder', 'form', 'funnel', 'gallery', 'gantt', 'html-editor', 'linear-gauge', 'list', 'load-indicator', 'load-panel', 'lookup', 'map', 'menu', 'multi-view', 'nested', 'number-box', 'pagination', 'pie-chart', 'pivot-grid-field-chooser', 'pivot-grid', 'polar-chart', 'popover', 'popup', 'progress-bar', 'radio-group', 'range-selector', 'range-slider', 'recurrence-editor', 'resizable', 'responsive-box', 'sankey', 'scheduler', 'scroll-view', 'select-box', 'slider', 'sortable', 'sparkline', 'speech-to-text', 'speed-dial-action', 'splitter', 'stepper', 'switch', 'tab-panel', 'tabs', 'tag-box', 'text-area', 'text-box', 'tile-view', 'toast', 'toolbar', 'tooltip', 'tree-list', 'tree-map', 'tree-view', 'validation-group', 'validation-summary', 'validator', 'vector-map', ]; window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, '@angular/platform-browser-dynamic': { 'esModule': true, }, '@angular/platform-browser': { 'esModule': true, }, '@angular/core': { 'esModule': true, }, '@angular/common': { 'esModule': true, }, '@angular/common/http': { 'esModule': true, }, '@angular/animations': { 'esModule': true, }, '@angular/forms': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', /* @angular */ '@angular/compiler': 'bundles:@angular/compiler.umd.js', '@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js', '@angular/core': 'bundles:@angular/core.umd.js', '@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js', '@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js', '@angular/common': 'bundles:@angular/common.umd.js', '@angular/common/http': 'bundles:@angular/common-http.umd.js', '@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js', '@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js', '@angular/forms': 'bundles:@angular/forms.umd.js', /* devextreme */ 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69', /* devextreme-angular umd maps */ 'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js', 'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js', 'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js', 'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js', 'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js', 'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js', 'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js', 'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js', 'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js', 'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js', 'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js', 'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js', 'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js', 'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js', 'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js', 'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js', 'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js', 'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js', ...componentNames.reduce((acc, name) => { acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`; acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`; return acc; }, {}), 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'tslib': 'npm:tslib/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', 'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devexpress-diagram@2.2.29/package.json', 'npm:devexpress-gantt@4.1.69/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line no-console // System.import('@angular/compiler').catch(console.error.bind(console)); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" }, "@angular/core": { "version": "21.2.17" }, "core-js": { "version": "2.6.12" }, "typescript": { "version": "5.9.3" }, "zone.js": { "version": "0.15.1" } };
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script> <script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Scheduler - Virtual Scrolling

With virtual scrolling, you can improve the overall performance of your application and reduce load times when our Scheduler component is bound to a large data set. When virtual scrolling is enabled, our Scheduler only renders visible appointments. When an appointment leaves the viewport, the Scheduler removes it from the DOM.

To enable virtual scrolling mode, set the scrolling.mode property to "virtual".

Virtual scrolling is available for all views except "agenda".

Backend API
<template> <DxScheduler :data-source="dataSource" :current-date="currentDate" :height="730" :start-day-hour="8" :end-day-hour="20" :cell-duration="60" :current-view="currentView" :show-all-day-panel="false" :groups="groups" > <DxView type="timelineWorkWeek" name="Timeline" group-orientation="vertical" /> <DxView type="workWeek" group-orientation="vertical" /> <DxView type="month" group-orientation="horizontal" /> <DxResource :data-source="resources" field-expr="humanId" label="Employee" icon="group" /> <DxScrolling mode="virtual" /> </DxScheduler> </template> <script setup lang="ts"> import DxScheduler, { DxResource, DxView, DxScrolling } from 'devextreme-vue/scheduler'; import { resources, generateAppointments } from './data.ts'; const dataSource = generateAppointments(new Date(2021, 1, 1), new Date(2021, 1, 28), 8, 20); const currentDate = new Date(2021, 1, 2); const currentView = 'Timeline'; const groups = ['humanId']; </script>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
interface Appointment { text: string, startDate: Date, endDate: Date, humanId: number } export const resources = [{ id: 0, text: 'David Carter', color: '#74d57b', }, { id: 1, text: 'Emma Lewis', color: '#1db2f5', }, { id: 2, text: 'Noah Hill', color: '#f5564a', }, { id: 3, text: 'William Bell', color: '#97c95c', }, { id: 4, text: 'Jane Jones', color: '#ffc720', }, { id: 5, text: 'Violet Young', color: '#eb3573', }, { id: 6, text: 'Samuel Perry', color: '#a63db8', }, { id: 7, text: 'Luther Murphy', color: '#ffaa66', }, { id: 8, text: 'Craig Morris', color: '#2dcdc4', }, { id: 9, text: 'Sandy Wood', color: '#c34cb9', }, { id: 10, text: 'Susan Bennett', color: '#3d44ec', }, { id: 11, text: 'Lilly Barnes', color: '#4ddcca', }, { id: 12, text: 'Marcus Price', color: '#2ec98d', }, { id: 13, text: 'David Stewart', color: '#3ff6ca', }, { id: 14, text: 'Joseph Smith', color: '#f665aa', }, { id: 15, text: 'Carter Wilson', color: '#d1c974', }, { id: 16, text: 'Wyatt Lopez', color: '#ff6741', }, { id: 17, text: 'John Long', color: '#ee53dc', }, { id: 18, text: 'Jack Rivera', color: '#795ac3', }, { id: 19, text: 'Victoria Adams', color: '#ff7d8a', }, { id: 20, text: 'Madison Anderson', color: '#4cd482', }, { id: 21, text: 'Luna Moore', color: '#9d67cc', }, { id: 22, text: 'Michael Bailey', color: '#5ab1ef', }, { id: 23, text: 'Jenny Powell', color: '#68e18f', }, { id: 24, text: 'Daniel Peterson', color: '#4dd155', }, { id: 25, text: 'Gabriel Gray', color: '#ef9e44', }, { id: 26, text: 'Anthony Robinson', color: '#45a5cc', }, { id: 27, text: 'Ellie Tomson', color: '#a067bd', }, { id: 28, text: 'Natalie Adams', color: '#3d44ec', }, { id: 29, text: 'Sofia Green', color: '#4ddcca', }]; const appointmentsText = [ 'Google AdWords Strategy', 'New Brochures', 'Brochure Design Review', 'Website Re-Design Plan', 'Rollout of New Website and Marketing Brochures', 'Update Sales Strategy Documents', 'Non-Compete Agreements', 'Approve Hiring of John Jeffers', 'Update NDA Agreement', 'Update Employee Files with New NDA', 'Submit Questions Regarding New NDA', 'Submit Signed NDA', 'Review Revenue Projections', 'Comment on Revenue Projections', 'Provide New Health Insurance Docs', 'Review Changes to Health Insurance Coverage', 'Review Training Course for any Ommissions', 'Recall Rebate Form', 'Create Report on Customer Feedback', 'Review Customer Feedback Report', 'Customer Feedback Report Analysis', 'Prepare Shipping Cost Analysis Report', 'Provide Feedback on Shippers', 'Select Preferred Shipper', 'Complete Shipper Selection Form', 'Upgrade Server Hardware', 'Upgrade Personal Computers', 'Upgrade Apps to Windows RT or stay with WinForms', 'Estimate Time Required to Touch-Enable Apps', 'Report on Tranistion to Touch-Based Apps', 'Submit New Website Design', 'Create Icons for Website', 'Create New Product Pages', 'Approve Website Launch', 'Update Customer Shipping Profiles', 'Create New Shipping Return Labels', 'Get Design for Shipping Return Labels', 'PSD needed for Shipping Return Labels', 'Contact ISP and Discuss Payment Options', 'Prepare Year-End Support Summary Report', 'Review New Training Material', 'Distribute Training Material to Support Staff', 'Training Material Distribution Schedule', 'Approval on Converting to New HDMI Specification', 'Create New Spike for Automation Server', 'Code Review - New Automation Server', 'Confirm Availability for Sales Meeting', 'Reschedule Sales Team Meeting', 'Send 2 Remotes for Giveaways', 'Discuss Product Giveaways with Management', 'Replace Desktops on the 3rd Floor', 'Update Database with New Leads', 'Mail New Leads for Follow Up', 'Send Territory Sales Breakdown', 'Territory Sales Breakdown Report', 'Report on the State of Engineering Dept', 'Staff Productivity Report', ]; function getRandomDuration(durationState: number) { const durationMin = Math.floor((durationState % 23) / 3 + 5) * 15; return durationMin * 60 * 1000; } function getRandomText(textIndex: number) { return appointmentsText[textIndex % appointmentsText.length]; } function filterAppointmentsByTime(appointments: Appointment[], startDayHour: number, endDayHour: number) { const result = []; for (let i = 0; i < appointments.length; i += 1) { const { startDate } = appointments[i]; const { endDate } = appointments[i]; if (startDate.getDay() === endDate.getDay() && startDate.getHours() >= startDayHour - 1 && endDate.getHours() <= endDayHour - 1) { result.push(appointments[i]); } } return result; } export function generateAppointments(startDay: Date, endDay: Date, startDayHour: number, endDayHour: number) { const appointments: Appointment[] = []; let textIndex = 0; let durationState = 1; const durationIncrement = 19; for (let i = 0; i < resources.length; i += 1) { let startDate = startDay; while (startDate.getTime() < endDay.getTime()) { durationState += durationIncrement; const endDate = new Date(startDate.getTime() + getRandomDuration(durationState)); appointments.push({ text: getRandomText(textIndex), startDate, endDate, humanId: resources[i].id, }); textIndex += 1; durationState += durationIncrement; startDate = new Date(endDate.getTime() + getRandomDuration(durationState)); } } return filterAppointmentsByTime(appointments, startDayHour, endDayHour); }
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#scheduler');
#scheduler .dx-scheduler-cell-sizes-vertical { height: 100px; } #scheduler .dx-scheduler-cell-sizes-horizontal { width: 100px; }
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="scheduler"> </div> </div> </body> </html>

Backend API
import React from 'react';
import Scheduler, { Resource, View, Scrolling } from 'devextreme-react/scheduler';
import { resources, generateAppointments } from './data.ts';
const currentDate = new Date(2021, 1, 2);
const groups = ['humanId'];
const startDay = new Date(2021, 1, 1);
const endDay = new Date(2021, 1, 28);
const startDayHour = 8;
const endDayHour = 20;
const appointments = generateAppointments(startDay, endDay, startDayHour, endDayHour);
const App = () => (
<Scheduler
dataSource={appointments}
height={730}
defaultCurrentView="Timeline"
defaultCurrentDate={currentDate}
startDayHour={startDayHour}
endDayHour={endDayHour}
cellDuration={60}
showAllDayPanel={false}
groups={groups}>
<View
type='timelineWorkWeek'
name='Timeline'
groupOrientation='vertical'
/>
<View
type='workWeek'
groupOrientation='vertical'
/>
<View
type='month'
groupOrientation='horizontal'
/>
<Resource
fieldExpr='humanId'
dataSource={resources}
label='Employee'
icon='group'
/>
<Scrolling
mode='virtual'
/>
</Scheduler>
);
export default App;
import React from 'react';
import Scheduler, { Resource, View, Scrolling } from 'devextreme-react/scheduler';
import { resources, generateAppointments } from './data.js';
const currentDate = new Date(2021, 1, 2);
const groups = ['humanId'];
const startDay = new Date(2021, 1, 1);
const endDay = new Date(2021, 1, 28);
const startDayHour = 8;
const endDayHour = 20;
const appointments = generateAppointments(startDay, endDay, startDayHour, endDayHour);
const App = () => (
<Scheduler
dataSource={appointments}
height={730}
defaultCurrentView="Timeline"
defaultCurrentDate={currentDate}
startDayHour={startDayHour}
endDayHour={endDayHour}
cellDuration={60}
showAllDayPanel={false}
groups={groups}
>
<View
type="timelineWorkWeek"
name="Timeline"
groupOrientation="vertical"
/>
<View
type="workWeek"
groupOrientation="vertical"
/>
<View
type="month"
groupOrientation="horizontal"
/>
<Resource
fieldExpr="humanId"
dataSource={resources}
label="Employee"
icon="group"
/>
<Scrolling mode="virtual" />
</Scheduler>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('scheduler'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
type Appointment = SchedulerTypes.Appointment & { humanId: number; };
type Resource = {
text: string;
id: number;
color: string;
};
export const resources: Resource[] = [{
id: 0,
text: 'David Carter',
color: '#74d57b',
}, {
id: 1,
text: 'Emma Lewis',
color: '#1db2f5',
}, {
id: 2,
text: 'Noah Hill',
color: '#f5564a',
}, {
id: 3,
text: 'William Bell',
color: '#97c95c',
}, {
id: 4,
text: 'Jane Jones',
color: '#ffc720',
}, {
id: 5,
text: 'Violet Young',
color: '#eb3573',
}, {
id: 6,
text: 'Samuel Perry',
color: '#a63db8',
}, {
id: 7,
text: 'Luther Murphy',
color: '#ffaa66',
}, {
id: 8,
text: 'Craig Morris',
color: '#2dcdc4',
}, {
id: 9,
text: 'Sandy Wood',
color: '#c34cb9',
}, {
id: 10,
text: 'Susan Bennett',
color: '#3d44ec',
}, {
id: 11,
text: 'Lilly Barnes',
color: '#4ddcca',
}, {
id: 12,
text: 'Marcus Price',
color: '#2ec98d',
}, {
id: 13,
text: 'David Stewart',
color: '#3ff6ca',
}, {
id: 14,
text: 'Joseph Smith',
color: '#f665aa',
}, {
id: 15,
text: 'Carter Wilson',
color: '#d1c974',
}, {
id: 16,
text: 'Wyatt Lopez',
color: '#ff6741',
}, {
id: 17,
text: 'John Long',
color: '#ee53dc',
}, {
id: 18,
text: 'Jack Rivera',
color: '#795ac3',
}, {
id: 19,
text: 'Victoria Adams',
color: '#ff7d8a',
}, {
id: 20,
text: 'Madison Anderson',
color: '#4cd482',
}, {
id: 21,
text: 'Luna Moore',
color: '#9d67cc',
}, {
id: 22,
text: 'Michael Bailey',
color: '#5ab1ef',
}, {
id: 23,
text: 'Jenny Powell',
color: '#68e18f',
}, {
id: 24,
text: 'Daniel Peterson',
color: '#4dd155',
}, {
id: 25,
text: 'Gabriel Gray',
color: '#ef9e44',
}, {
id: 26,
text: 'Anthony Robinson',
color: '#45a5cc',
}, {
id: 27,
text: 'Ellie Tomson',
color: '#a067bd',
}, {
id: 28,
text: 'Natalie Adams',
color: '#3d44ec',
}, {
id: 29,
text: 'Sofia Green',
color: '#4ddcca',
}];
const appointmentsText = [
'Google AdWords Strategy',
'New Brochures',
'Brochure Design Review',
'Website Re-Design Plan',
'Rollout of New Website and Marketing Brochures',
'Update Sales Strategy Documents',
'Non-Compete Agreements',
'Approve Hiring of John Jeffers',
'Update NDA Agreement',
'Update Employee Files with New NDA',
'Submit Questions Regarding New NDA',
'Submit Signed NDA',
'Review Revenue Projections',
'Comment on Revenue Projections',
'Provide New Health Insurance Docs',
'Review Changes to Health Insurance Coverage',
'Review Training Course for any Ommissions',
'Recall Rebate Form',
'Create Report on Customer Feedback',
'Review Customer Feedback Report',
'Customer Feedback Report Analysis',
'Prepare Shipping Cost Analysis Report',
'Provide Feedback on Shippers',
'Select Preferred Shipper',
'Complete Shipper Selection Form',
'Upgrade Server Hardware',
'Upgrade Personal Computers',
'Upgrade Apps to Windows RT or stay with WinForms',
'Estimate Time Required to Touch-Enable Apps',
'Report on Tranistion to Touch-Based Apps',
'Submit New Website Design',
'Create Icons for Website',
'Create New Product Pages',
'Approve Website Launch',
'Update Customer Shipping Profiles',
'Create New Shipping Return Labels',
'Get Design for Shipping Return Labels',
'PSD needed for Shipping Return Labels',
'Contact ISP and Discuss Payment Options',
'Prepare Year-End Support Summary Report',
'Review New Training Material',
'Distribute Training Material to Support Staff',
'Training Material Distribution Schedule',
'Approval on Converting to New HDMI Specification',
'Create New Spike for Automation Server',
'Code Review - New Automation Server',
'Confirm Availability for Sales Meeting',
'Reschedule Sales Team Meeting',
'Send 2 Remotes for Giveaways',
'Discuss Product Giveaways with Management',
'Replace Desktops on the 3rd Floor',
'Update Database with New Leads',
'Mail New Leads for Follow Up',
'Send Territory Sales Breakdown',
'Territory Sales Breakdown Report',
'Report on the State of Engineering Dept',
'Staff Productivity Report',
];
function getRandomDuration(durationState: number) {
const durationMin = Math.floor((durationState % 23) / 3 + 5) * 15;
return durationMin * 60 * 1000;
}
function getRandomText(textIndex: number) {
return appointmentsText[textIndex % appointmentsText.length];
}
function filterAppointmentsByTime(appointments: string | any[], startDayHour: number, endDayHour: number) {
const result: any[] = [];
for (let i = 0; i < appointments.length; i += 1) {
const { startDate } = appointments[i];
const { endDate } = appointments[i];
if (startDate.getDay() === endDate.getDay()
&& startDate.getHours() >= startDayHour - 1
&& endDate.getHours() <= endDayHour - 1) {
result.push(appointments[i]);
}
}
return result;
}
export function generateAppointments(startDay: Date, endDay: Date, startDayHour: number, endDayHour: number) {
const appointments: Appointment[] = [];
let textIndex = 0;
let durationState = 1;
const durationIncrement = 19;
for (let i = 0; i < resources.length; i += 1) {
let startDate = startDay;
while (startDate.getTime() < endDay.getTime()) {
durationState += durationIncrement;
const endDate = new Date(startDate.getTime() + getRandomDuration(durationState));
appointments.push({
text: getRandomText(textIndex),
startDate,
endDate,
humanId: resources[i].id,
});
textIndex += 1;
durationState += durationIncrement;
startDate = new Date(endDate.getTime() + getRandomDuration(durationState));
}
}
return filterAppointmentsByTime(appointments, startDayHour, endDayHour);
}
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('scheduler'));
export const resources = [
{
id: 0,
text: 'David Carter',
color: '#74d57b',
},
{
id: 1,
text: 'Emma Lewis',
color: '#1db2f5',
},
{
id: 2,
text: 'Noah Hill',
color: '#f5564a',
},
{
id: 3,
text: 'William Bell',
color: '#97c95c',
},
{
id: 4,
text: 'Jane Jones',
color: '#ffc720',
},
{
id: 5,
text: 'Violet Young',
color: '#eb3573',
},
{
id: 6,
text: 'Samuel Perry',
color: '#a63db8',
},
{
id: 7,
text: 'Luther Murphy',
color: '#ffaa66',
},
{
id: 8,
text: 'Craig Morris',
color: '#2dcdc4',
},
{
id: 9,
text: 'Sandy Wood',
color: '#c34cb9',
},
{
id: 10,
text: 'Susan Bennett',
color: '#3d44ec',
},
{
id: 11,
text: 'Lilly Barnes',
color: '#4ddcca',
},
{
id: 12,
text: 'Marcus Price',
color: '#2ec98d',
},
{
id: 13,
text: 'David Stewart',
color: '#3ff6ca',
},
{
id: 14,
text: 'Joseph Smith',
color: '#f665aa',
},
{
id: 15,
text: 'Carter Wilson',
color: '#d1c974',
},
{
id: 16,
text: 'Wyatt Lopez',
color: '#ff6741',
},
{
id: 17,
text: 'John Long',
color: '#ee53dc',
},
{
id: 18,
text: 'Jack Rivera',
color: '#795ac3',
},
{
id: 19,
text: 'Victoria Adams',
color: '#ff7d8a',
},
{
id: 20,
text: 'Madison Anderson',
color: '#4cd482',
},
{
id: 21,
text: 'Luna Moore',
color: '#9d67cc',
},
{
id: 22,
text: 'Michael Bailey',
color: '#5ab1ef',
},
{
id: 23,
text: 'Jenny Powell',
color: '#68e18f',
},
{
id: 24,
text: 'Daniel Peterson',
color: '#4dd155',
},
{
id: 25,
text: 'Gabriel Gray',
color: '#ef9e44',
},
{
id: 26,
text: 'Anthony Robinson',
color: '#45a5cc',
},
{
id: 27,
text: 'Ellie Tomson',
color: '#a067bd',
},
{
id: 28,
text: 'Natalie Adams',
color: '#3d44ec',
},
{
id: 29,
text: 'Sofia Green',
color: '#4ddcca',
},
];
const appointmentsText = [
'Google AdWords Strategy',
'New Brochures',
'Brochure Design Review',
'Website Re-Design Plan',
'Rollout of New Website and Marketing Brochures',
'Update Sales Strategy Documents',
'Non-Compete Agreements',
'Approve Hiring of John Jeffers',
'Update NDA Agreement',
'Update Employee Files with New NDA',
'Submit Questions Regarding New NDA',
'Submit Signed NDA',
'Review Revenue Projections',
'Comment on Revenue Projections',
'Provide New Health Insurance Docs',
'Review Changes to Health Insurance Coverage',
'Review Training Course for any Ommissions',
'Recall Rebate Form',
'Create Report on Customer Feedback',
'Review Customer Feedback Report',
'Customer Feedback Report Analysis',
'Prepare Shipping Cost Analysis Report',
'Provide Feedback on Shippers',
'Select Preferred Shipper',
'Complete Shipper Selection Form',
'Upgrade Server Hardware',
'Upgrade Personal Computers',
'Upgrade Apps to Windows RT or stay with WinForms',
'Estimate Time Required to Touch-Enable Apps',
'Report on Tranistion to Touch-Based Apps',
'Submit New Website Design',
'Create Icons for Website',
'Create New Product Pages',
'Approve Website Launch',
'Update Customer Shipping Profiles',
'Create New Shipping Return Labels',
'Get Design for Shipping Return Labels',
'PSD needed for Shipping Return Labels',
'Contact ISP and Discuss Payment Options',
'Prepare Year-End Support Summary Report',
'Review New Training Material',
'Distribute Training Material to Support Staff',
'Training Material Distribution Schedule',
'Approval on Converting to New HDMI Specification',
'Create New Spike for Automation Server',
'Code Review - New Automation Server',
'Confirm Availability for Sales Meeting',
'Reschedule Sales Team Meeting',
'Send 2 Remotes for Giveaways',
'Discuss Product Giveaways with Management',
'Replace Desktops on the 3rd Floor',
'Update Database with New Leads',
'Mail New Leads for Follow Up',
'Send Territory Sales Breakdown',
'Territory Sales Breakdown Report',
'Report on the State of Engineering Dept',
'Staff Productivity Report',
];
function getRandomDuration(durationState) {
const durationMin = Math.floor((durationState % 23) / 3 + 5) * 15;
return durationMin * 60 * 1000;
}
function getRandomText(textIndex) {
return appointmentsText[textIndex % appointmentsText.length];
}
function filterAppointmentsByTime(appointments, startDayHour, endDayHour) {
const result = [];
for (let i = 0; i < appointments.length; i += 1) {
const { startDate } = appointments[i];
const { endDate } = appointments[i];
if (
startDate.getDay() === endDate.getDay() &&
startDate.getHours() >= startDayHour - 1 &&
endDate.getHours() <= endDayHour - 1
) {
result.push(appointments[i]);
}
}
return result;
}
export function generateAppointments(startDay, endDay, startDayHour, endDayHour) {
const appointments = [];
let textIndex = 0;
let durationState = 1;
const durationIncrement = 19;
for (let i = 0; i < resources.length; i += 1) {
let startDate = startDay;
while (startDate.getTime() < endDay.getTime()) {
durationState += durationIncrement;
const endDate = new Date(startDate.getTime() + getRandomDuration(durationState));
appointments.push({
text: getRandomText(textIndex),
startDate,
endDate,
humanId: resources[i].id,
});
textIndex += 1;
durationState += durationIncrement;
startDate = new Date(endDate.getTime() + getRandomDuration(durationState));
}
}
return filterAppointmentsByTime(appointments, startDayHour, endDayHour);
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
</div>
</body>
</html>
#scheduler .dx-scheduler-cell-sizes-vertical {
height: 100px;
}
#scheduler .dx-scheduler-cell-sizes-horizontal {
width: 100px;
}